(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('ngx-reactive-form/declarations'), require('@angular/core'), require('@angular/forms'), require('ngx-reactive-form/dependant-validator'), require('ngx-reactive-form/utils'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('ngx-reactive-form', ['exports', 'ngx-reactive-form/declarations', '@angular/core', '@angular/forms', 'ngx-reactive-form/dependant-validator', 'ngx-reactive-form/utils', 'rxjs', 'rxjs/operators'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["ngx-reactive-form"] = {}, global["ngx-reactive-form"].declarations, global.ng.core, global.ng.forms, global["ngx-reactive-form"]["dependant-validator"], global["ngx-reactive-form"].utils, global.rxjs, global.rxjs.operators));
})(this, (function (exports, declarations, i0, forms, dependantValidator, utils, rxjs, operators) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var _FormUtils_root, _FormUtils_compositeValidator, _FormUtils_compositeAsyncValidator;
    var FormUtils = /** @class */ (function () {
        function FormUtils(injector, rootFn) {
            var _this = this;
            this.injector = injector;
            this.rootFn = rootFn;
            _FormUtils_root.set(this, utils.lazy(function () {
                if (_this.rootFn instanceof forms.FormGroup || _this.rootFn instanceof forms.FormArray) {
                    return _this.rootFn;
                }
                else if (typeof _this.rootFn === 'function') {
                    return _this.rootFn();
                }
            }));
            _FormUtils_compositeValidator.set(this, utils.lazy(function () {
                var v = utils.compositeValidator();
                return function () { return v(_this.root); };
            }));
            _FormUtils_compositeAsyncValidator.set(this, utils.lazy(function () {
                var v = utils.compositeAsyncValidator();
                return function () { return v(_this.root); };
            }));
        }
        Object.defineProperty(FormUtils.prototype, "root", {
            get: function () {
                var r = __classPrivateFieldGet(this, _FormUtils_root, "f");
                if (!r()) {
                    r.reset();
                }
                return r();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FormUtils.prototype, "compositeValidator", {
            get: function () { return __classPrivateFieldGet(this, _FormUtils_compositeValidator, "f").call(this); },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FormUtils.prototype, "compositeAsyncValidator", {
            get: function () { return __classPrivateFieldGet(this, _FormUtils_compositeAsyncValidator, "f").call(this); },
            enumerable: false,
            configurable: true
        });
        FormUtils.prototype.tapControls = function (action, updateState) {
            if (updateState === void 0) { updateState = true; }
            utils.tapControls(this.root, action, updateState);
        };
        FormUtils.prototype.createDependentValidator = function (builderFn) {
            var _this = this;
            return new dependantValidator.DependentValidatorImpl(function () { return _this.root; }, builderFn);
        };
        FormUtils.prototype.makePristine = function () {
            this.tapControls(function (ctrl) {
                ctrl.markAsPristine();
                ctrl.markAsUntouched();
            });
        };
        FormUtils.prototype.makeDirty = function () {
            this.tapControls(function (ctrl) {
                ctrl.markAsDirty();
                ctrl.markAsTouched();
            });
        };
        /**
         * Consume this method on **NG_VALUE_ACCESSOR** `afterViewInit()`
         * ### Note
         * Add `ExtendedFormBuilder` to component providers
         */
        FormUtils.prototype.registerSubFormValidator = function () {
            var _this = this;
            var _a, _b, _c;
            var subscriptions = [];
            var ctrl = (_a = this.injector.get(forms.NgControl, null, i0.InjectFlags.Self)) === null || _a === void 0 ? void 0 : _a.control;
            if (ctrl) {
                (_b = ctrl.validator) !== null && _b !== void 0 ? _b : (ctrl.validator = this.compositeValidator);
                (_c = ctrl.asyncValidator) !== null && _c !== void 0 ? _c : (ctrl.asyncValidator = this.compositeAsyncValidator);
                subscriptions.push(ctrl.statusChanges.pipe(operators.map(function () { return ctrl.invalid; }), operators.debounceTime(50)).subscribe(function (invalid) {
                    _this.root.updateValueAndValidity({ emitEvent: true });
                    if (invalid && !ctrl.pristine) {
                        _this.makeDirty();
                    }
                }));
            }
            return new rxjs.Subscription(function () { return subscriptions.forEach(function (s) { return s.unsubscribe(); }); });
        };
        return FormUtils;
    }());
    _FormUtils_root = new WeakMap(), _FormUtils_compositeValidator = new WeakMap(), _FormUtils_compositeAsyncValidator = new WeakMap();

    var ExtendedFormBuilderResult = /** @class */ (function () {
        function ExtendedFormBuilderResult(injector, factory) {
            var _this = this;
            this.injector = injector;
            this.factory = factory;
            this.fb = this.injector.get(forms.FormBuilder);
            this.validators = [];
            this._formUtils = utils.lazy(function () { return new FormUtils(_this.injector, function () { return _this.form; }); });
            this.form = this.factory(this.fb, function (dv) {
                var v = _this.formUtils.createDependentValidator(dv);
                _this.validators.push(v);
                return v;
            });
        }
        Object.defineProperty(ExtendedFormBuilderResult.prototype, "formUtils", {
            get: function () {
                return this._formUtils();
            },
            enumerable: false,
            configurable: true
        });
        ExtendedFormBuilderResult.prototype.updateValidators = function () {
            this.validators.forEach(function (item) { return item.reset(); });
            this.formUtils.tapControls();
        };
        return ExtendedFormBuilderResult;
    }());
    var ExtendedFormBuilder = /** @class */ (function () {
        function ExtendedFormBuilder(injector) {
            this.injector = injector;
        }
        ExtendedFormBuilder.prototype.build = function (factory) {
            return new ExtendedFormBuilderResult(this.injector, factory);
        };
        return ExtendedFormBuilder;
    }());
    ExtendedFormBuilder.ɵprov = i0__namespace.ɵɵdefineInjectable({ factory: function ExtendedFormBuilder_Factory() { return new ExtendedFormBuilder(i0__namespace.ɵɵinject(i0__namespace.INJECTOR)); }, token: ExtendedFormBuilder, providedIn: "root" });
    ExtendedFormBuilder.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    ExtendedFormBuilder.ctorParameters = function () { return [
        { type: i0.Injector }
    ]; };

    /**
     * Generated bundle index. Do not edit.
     */

    Object.defineProperty(exports, 'compositeAsyncValidator', {
        enumerable: true,
        get: function () { return utils.compositeAsyncValidator; }
    });
    Object.defineProperty(exports, 'compositeValidator', {
        enumerable: true,
        get: function () { return utils.compositeValidator; }
    });
    Object.defineProperty(exports, 'tapControls', {
        enumerable: true,
        get: function () { return utils.tapControls; }
    });
    Object.defineProperty(exports, 'traverseControl', {
        enumerable: true,
        get: function () { return utils.traverseControl; }
    });
    exports.ExtendedFormBuilder = ExtendedFormBuilder;
    exports.FormUtils = FormUtils;
    Object.keys(declarations).forEach(function (k) {
        if (k !== 'default' && !exports.hasOwnProperty(k)) Object.defineProperty(exports, k, {
            enumerable: true,
            get: function () { return declarations[k]; }
        });
    });

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-reactive-form.umd.js.map
